var path = require('path');
var fs = require('fs-extra');
var encoder = require('plantuml-encoder')


function processBlock(block) {

    var src = block.body;
    if (!!block.kwargs.src) {
        src = fs.readFileSync(block.kwargs.src , "utf8");
    }

    var config = this.config.get('pluginsConfig.uml-online', {});
    if (!!block.kwargs.config) {
        config = block.kwargs.config;
    }

    var format = "svg";
    if (!!config && !!config.format) {
        format = config.format;
    }

    var host = "https://www.plantuml.com/plantuml/";
    if (!!config && !!config.host) {
        host = config.host;
    }
    host = host.replace(/\/+$/, '');

    src = encoder.encode(src);

    return "<img src=\"" + host + "/" + format + "/" + src + "\">";
}

module.exports = {
    blocks: {
        uml: {
            process: processBlock
        }
    },
    hooks: {
        // ensure parser gets correct input
        "page:before": function(page) {
            umls = page.content.match(/^```(plant|p)?uml((.*[\r\n]+)+?)?```$/igm);
            if (umls instanceof Array) {
                for (var i = 0, len = umls.length; i < len; i++) {
                    page.content = page.content.replace(umls[i], umls[i].replace(/^```(plant|p)?uml/, '{% uml %}').replace(/```$/, '{% enduml %}'));
                }
            }
            return page;
        }
    }
};
